# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetClientConfigResult',
    'AwaitableGetClientConfigResult',
    'get_client_config',
]

@pulumi.output_type
class GetClientConfigResult:
    """
    A collection of values returned by getClientConfig.
    """
    def __init__(__self__, cloud_id=None, folder_id=None, iam_token=None, id=None, zone=None):
        if cloud_id and not isinstance(cloud_id, str):
            raise TypeError("Expected argument 'cloud_id' to be a str")
        pulumi.set(__self__, "cloud_id", cloud_id)
        if folder_id and not isinstance(folder_id, str):
            raise TypeError("Expected argument 'folder_id' to be a str")
        pulumi.set(__self__, "folder_id", folder_id)
        if iam_token and not isinstance(iam_token, str):
            raise TypeError("Expected argument 'iam_token' to be a str")
        pulumi.set(__self__, "iam_token", iam_token)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if zone and not isinstance(zone, str):
            raise TypeError("Expected argument 'zone' to be a str")
        pulumi.set(__self__, "zone", zone)

    @property
    @pulumi.getter(name="cloudId")
    def cloud_id(self) -> str:
        """
        The ID of the cloud that the provider is connecting to.
        """
        return pulumi.get(self, "cloud_id")

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> str:
        """
        The ID of the folder in which we operate.
        """
        return pulumi.get(self, "folder_id")

    @property
    @pulumi.getter(name="iamToken")
    def iam_token(self) -> str:
        """
        A short-lived token that can be used for authentication in a Kubernetes cluster.
        """
        return pulumi.get(self, "iam_token")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def zone(self) -> str:
        """
        The default availability zone.
        """
        return pulumi.get(self, "zone")


class AwaitableGetClientConfigResult(GetClientConfigResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetClientConfigResult(
            cloud_id=self.cloud_id,
            folder_id=self.folder_id,
            iam_token=self.iam_token,
            id=self.id,
            zone=self.zone)


def get_client_config(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetClientConfigResult:
    """
    Get attributes used by provider to configure client connection.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_yandex as yandex

    client = yandex.get_client_config()
    kubernetes = yandex.get_kubernetes_cluster(name="kubernetes")
    ```
    """
    __args__ = dict()
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('yandex:index/getClientConfig:getClientConfig', __args__, opts=opts, typ=GetClientConfigResult).value

    return AwaitableGetClientConfigResult(
        cloud_id=__ret__.cloud_id,
        folder_id=__ret__.folder_id,
        iam_token=__ret__.iam_token,
        id=__ret__.id,
        zone=__ret__.zone)
