# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetIotCoreDeviceResult',
    'AwaitableGetIotCoreDeviceResult',
    'get_iot_core_device',
]

@pulumi.output_type
class GetIotCoreDeviceResult:
    """
    A collection of values returned by getIotCoreDevice.
    """
    def __init__(__self__, aliases=None, certificates=None, created_at=None, description=None, device_id=None, id=None, name=None, passwords=None, registry_id=None):
        if aliases and not isinstance(aliases, dict):
            raise TypeError("Expected argument 'aliases' to be a dict")
        pulumi.set(__self__, "aliases", aliases)
        if certificates and not isinstance(certificates, list):
            raise TypeError("Expected argument 'certificates' to be a list")
        pulumi.set(__self__, "certificates", certificates)
        if created_at and not isinstance(created_at, str):
            raise TypeError("Expected argument 'created_at' to be a str")
        pulumi.set(__self__, "created_at", created_at)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if device_id and not isinstance(device_id, str):
            raise TypeError("Expected argument 'device_id' to be a str")
        pulumi.set(__self__, "device_id", device_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if passwords and not isinstance(passwords, list):
            raise TypeError("Expected argument 'passwords' to be a list")
        pulumi.set(__self__, "passwords", passwords)
        if registry_id and not isinstance(registry_id, str):
            raise TypeError("Expected argument 'registry_id' to be a str")
        pulumi.set(__self__, "registry_id", registry_id)

    @property
    @pulumi.getter
    def aliases(self) -> Mapping[str, str]:
        """
        A set of key/value aliases pairs to assign to the IoT Core Device
        """
        return pulumi.get(self, "aliases")

    @property
    @pulumi.getter
    def certificates(self) -> Sequence[str]:
        """
        A set of certificate's fingerprints for the IoT Core Device
        """
        return pulumi.get(self, "certificates")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> str:
        """
        Creation timestamp of the IoT Core Device
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Description of the IoT Core Device
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="deviceId")
    def device_id(self) -> Optional[str]:
        return pulumi.get(self, "device_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def passwords(self) -> Sequence[str]:
        """
        A set of passwords's id for the IoT Core Device
        """
        return pulumi.get(self, "passwords")

    @property
    @pulumi.getter(name="registryId")
    def registry_id(self) -> str:
        """
        IoT Core Registry ID for the IoT Core Device
        """
        return pulumi.get(self, "registry_id")


class AwaitableGetIotCoreDeviceResult(GetIotCoreDeviceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetIotCoreDeviceResult(
            aliases=self.aliases,
            certificates=self.certificates,
            created_at=self.created_at,
            description=self.description,
            device_id=self.device_id,
            id=self.id,
            name=self.name,
            passwords=self.passwords,
            registry_id=self.registry_id)


def get_iot_core_device(device_id: Optional[str] = None,
                        name: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetIotCoreDeviceResult:
    """
    Get information about a Yandex IoT Core device. For more information about IoT Core, see
    [Yandex.Cloud IoT Device](https://cloud.yandex.com/docs/iot-core/quickstart).

    ```python
    import pulumi
    import pulumi_yandex as yandex

    my_device = yandex.get_iot_core_device(device_id="are1sampleregistry11")
    ```

    This data source is used to define [Yandex.Cloud IoT Device](https://cloud.yandex.com/docs/iot-core/quickstart) that can be used by other resources.


    :param str device_id: IoT Core Device id used to define device
    :param str name: IoT Core Device name used to define device
    """
    __args__ = dict()
    __args__['deviceId'] = device_id
    __args__['name'] = name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('yandex:index/getIotCoreDevice:getIotCoreDevice', __args__, opts=opts, typ=GetIotCoreDeviceResult).value

    return AwaitableGetIotCoreDeviceResult(
        aliases=__ret__.aliases,
        certificates=__ret__.certificates,
        created_at=__ret__.created_at,
        description=__ret__.description,
        device_id=__ret__.device_id,
        id=__ret__.id,
        name=__ret__.name,
        passwords=__ret__.passwords,
        registry_id=__ret__.registry_id)
