# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['MdbClickhouseClusterArgs', 'MdbClickhouseCluster']

@pulumi.input_type
class MdbClickhouseClusterArgs:
    def __init__(__self__, *,
                 clickhouse: pulumi.Input['MdbClickhouseClusterClickhouseArgs'],
                 environment: pulumi.Input[str],
                 hosts: pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterHostArgs']]],
                 network_id: pulumi.Input[str],
                 access: Optional[pulumi.Input['MdbClickhouseClusterAccessArgs']] = None,
                 admin_password: Optional[pulumi.Input[str]] = None,
                 backup_window_start: Optional[pulumi.Input['MdbClickhouseClusterBackupWindowStartArgs']] = None,
                 cloud_storage: Optional[pulumi.Input['MdbClickhouseClusterCloudStorageArgs']] = None,
                 copy_schema_on_new_hosts: Optional[pulumi.Input[bool]] = None,
                 databases: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterDatabaseArgs']]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 format_schemas: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterFormatSchemaArgs']]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 ml_models: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterMlModelArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 shard_groups: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterShardGroupArgs']]]] = None,
                 sql_database_management: Optional[pulumi.Input[bool]] = None,
                 sql_user_management: Optional[pulumi.Input[bool]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterUserArgs']]]] = None,
                 version: Optional[pulumi.Input[str]] = None,
                 zookeeper: Optional[pulumi.Input['MdbClickhouseClusterZookeeperArgs']] = None):
        """
        The set of arguments for constructing a MdbClickhouseCluster resource.
        :param pulumi.Input['MdbClickhouseClusterClickhouseArgs'] clickhouse: Configuration of the ClickHouse subcluster. The structure is documented below.
        :param pulumi.Input[str] environment: Deployment environment of the ClickHouse cluster. Can be either `PRESTABLE` or `PRODUCTION`.
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterHostArgs']]] hosts: A host of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] network_id: ID of the network, to which the ClickHouse cluster belongs.
        :param pulumi.Input['MdbClickhouseClusterAccessArgs'] access: Access policy to the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] admin_password: A password used to authorize as user `admin` when `sql_user_management` enabled.
        :param pulumi.Input['MdbClickhouseClusterBackupWindowStartArgs'] backup_window_start: Time to start the daily backup, in the UTC timezone. The structure is documented below.
        :param pulumi.Input[bool] copy_schema_on_new_hosts: Whether to copy schema on new ClickHouse hosts.
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterDatabaseArgs']]] databases: A database of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] description: Description of the shard group.
        :param pulumi.Input[str] folder_id: The ID of the folder that the resource belongs to. If it
               is not provided, the default provider folder is used.
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterFormatSchemaArgs']]] format_schemas: A set of protobuf or capnproto format schemas. The structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the ClickHouse cluster.
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterMlModelArgs']]] ml_models: A group of machine learning models. The structure is documented below
        :param pulumi.Input[str] name: Graphite rollup configuration name.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: A set of ids of security groups assigned to hosts of the cluster.
        :param pulumi.Input[str] service_account_id: ID of the service account used for access to Yandex Object Storage.
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterShardGroupArgs']]] shard_groups: A group of clickhouse shards. The structure is documented below.
        :param pulumi.Input[bool] sql_database_management: Grants `admin` user database management permission.
        :param pulumi.Input[bool] sql_user_management: Enables `admin` user with user management permission.
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterUserArgs']]] users: A user of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] version: Version of the ClickHouse server software.
        :param pulumi.Input['MdbClickhouseClusterZookeeperArgs'] zookeeper: Configuration of the ZooKeeper subcluster. The structure is documented below.
        """
        pulumi.set(__self__, "clickhouse", clickhouse)
        pulumi.set(__self__, "environment", environment)
        pulumi.set(__self__, "hosts", hosts)
        pulumi.set(__self__, "network_id", network_id)
        if access is not None:
            pulumi.set(__self__, "access", access)
        if admin_password is not None:
            pulumi.set(__self__, "admin_password", admin_password)
        if backup_window_start is not None:
            pulumi.set(__self__, "backup_window_start", backup_window_start)
        if cloud_storage is not None:
            pulumi.set(__self__, "cloud_storage", cloud_storage)
        if copy_schema_on_new_hosts is not None:
            pulumi.set(__self__, "copy_schema_on_new_hosts", copy_schema_on_new_hosts)
        if databases is not None:
            pulumi.set(__self__, "databases", databases)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if folder_id is not None:
            pulumi.set(__self__, "folder_id", folder_id)
        if format_schemas is not None:
            pulumi.set(__self__, "format_schemas", format_schemas)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if ml_models is not None:
            pulumi.set(__self__, "ml_models", ml_models)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if security_group_ids is not None:
            pulumi.set(__self__, "security_group_ids", security_group_ids)
        if service_account_id is not None:
            pulumi.set(__self__, "service_account_id", service_account_id)
        if shard_groups is not None:
            pulumi.set(__self__, "shard_groups", shard_groups)
        if sql_database_management is not None:
            pulumi.set(__self__, "sql_database_management", sql_database_management)
        if sql_user_management is not None:
            pulumi.set(__self__, "sql_user_management", sql_user_management)
        if users is not None:
            pulumi.set(__self__, "users", users)
        if version is not None:
            pulumi.set(__self__, "version", version)
        if zookeeper is not None:
            pulumi.set(__self__, "zookeeper", zookeeper)

    @property
    @pulumi.getter
    def clickhouse(self) -> pulumi.Input['MdbClickhouseClusterClickhouseArgs']:
        """
        Configuration of the ClickHouse subcluster. The structure is documented below.
        """
        return pulumi.get(self, "clickhouse")

    @clickhouse.setter
    def clickhouse(self, value: pulumi.Input['MdbClickhouseClusterClickhouseArgs']):
        pulumi.set(self, "clickhouse", value)

    @property
    @pulumi.getter
    def environment(self) -> pulumi.Input[str]:
        """
        Deployment environment of the ClickHouse cluster. Can be either `PRESTABLE` or `PRODUCTION`.
        """
        return pulumi.get(self, "environment")

    @environment.setter
    def environment(self, value: pulumi.Input[str]):
        pulumi.set(self, "environment", value)

    @property
    @pulumi.getter
    def hosts(self) -> pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterHostArgs']]]:
        """
        A host of the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "hosts")

    @hosts.setter
    def hosts(self, value: pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterHostArgs']]]):
        pulumi.set(self, "hosts", value)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Input[str]:
        """
        ID of the network, to which the ClickHouse cluster belongs.
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter
    def access(self) -> Optional[pulumi.Input['MdbClickhouseClusterAccessArgs']]:
        """
        Access policy to the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "access")

    @access.setter
    def access(self, value: Optional[pulumi.Input['MdbClickhouseClusterAccessArgs']]):
        pulumi.set(self, "access", value)

    @property
    @pulumi.getter(name="adminPassword")
    def admin_password(self) -> Optional[pulumi.Input[str]]:
        """
        A password used to authorize as user `admin` when `sql_user_management` enabled.
        """
        return pulumi.get(self, "admin_password")

    @admin_password.setter
    def admin_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "admin_password", value)

    @property
    @pulumi.getter(name="backupWindowStart")
    def backup_window_start(self) -> Optional[pulumi.Input['MdbClickhouseClusterBackupWindowStartArgs']]:
        """
        Time to start the daily backup, in the UTC timezone. The structure is documented below.
        """
        return pulumi.get(self, "backup_window_start")

    @backup_window_start.setter
    def backup_window_start(self, value: Optional[pulumi.Input['MdbClickhouseClusterBackupWindowStartArgs']]):
        pulumi.set(self, "backup_window_start", value)

    @property
    @pulumi.getter(name="cloudStorage")
    def cloud_storage(self) -> Optional[pulumi.Input['MdbClickhouseClusterCloudStorageArgs']]:
        return pulumi.get(self, "cloud_storage")

    @cloud_storage.setter
    def cloud_storage(self, value: Optional[pulumi.Input['MdbClickhouseClusterCloudStorageArgs']]):
        pulumi.set(self, "cloud_storage", value)

    @property
    @pulumi.getter(name="copySchemaOnNewHosts")
    def copy_schema_on_new_hosts(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to copy schema on new ClickHouse hosts.
        """
        return pulumi.get(self, "copy_schema_on_new_hosts")

    @copy_schema_on_new_hosts.setter
    def copy_schema_on_new_hosts(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "copy_schema_on_new_hosts", value)

    @property
    @pulumi.getter
    def databases(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterDatabaseArgs']]]]:
        """
        A database of the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "databases")

    @databases.setter
    def databases(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterDatabaseArgs']]]]):
        pulumi.set(self, "databases", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the shard group.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the folder that the resource belongs to. If it
        is not provided, the default provider folder is used.
        """
        return pulumi.get(self, "folder_id")

    @folder_id.setter
    def folder_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder_id", value)

    @property
    @pulumi.getter(name="formatSchemas")
    def format_schemas(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterFormatSchemaArgs']]]]:
        """
        A set of protobuf or capnproto format schemas. The structure is documented below.
        """
        return pulumi.get(self, "format_schemas")

    @format_schemas.setter
    def format_schemas(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterFormatSchemaArgs']]]]):
        pulumi.set(self, "format_schemas", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A set of key/value label pairs to assign to the ClickHouse cluster.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter(name="mlModels")
    def ml_models(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterMlModelArgs']]]]:
        """
        A group of machine learning models. The structure is documented below
        """
        return pulumi.get(self, "ml_models")

    @ml_models.setter
    def ml_models(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterMlModelArgs']]]]):
        pulumi.set(self, "ml_models", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Graphite rollup configuration name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A set of ids of security groups assigned to hosts of the cluster.
        """
        return pulumi.get(self, "security_group_ids")

    @security_group_ids.setter
    def security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_group_ids", value)

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the service account used for access to Yandex Object Storage.
        """
        return pulumi.get(self, "service_account_id")

    @service_account_id.setter
    def service_account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_account_id", value)

    @property
    @pulumi.getter(name="shardGroups")
    def shard_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterShardGroupArgs']]]]:
        """
        A group of clickhouse shards. The structure is documented below.
        """
        return pulumi.get(self, "shard_groups")

    @shard_groups.setter
    def shard_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterShardGroupArgs']]]]):
        pulumi.set(self, "shard_groups", value)

    @property
    @pulumi.getter(name="sqlDatabaseManagement")
    def sql_database_management(self) -> Optional[pulumi.Input[bool]]:
        """
        Grants `admin` user database management permission.
        """
        return pulumi.get(self, "sql_database_management")

    @sql_database_management.setter
    def sql_database_management(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "sql_database_management", value)

    @property
    @pulumi.getter(name="sqlUserManagement")
    def sql_user_management(self) -> Optional[pulumi.Input[bool]]:
        """
        Enables `admin` user with user management permission.
        """
        return pulumi.get(self, "sql_user_management")

    @sql_user_management.setter
    def sql_user_management(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "sql_user_management", value)

    @property
    @pulumi.getter
    def users(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterUserArgs']]]]:
        """
        A user of the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterUserArgs']]]]):
        pulumi.set(self, "users", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[str]]:
        """
        Version of the ClickHouse server software.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter
    def zookeeper(self) -> Optional[pulumi.Input['MdbClickhouseClusterZookeeperArgs']]:
        """
        Configuration of the ZooKeeper subcluster. The structure is documented below.
        """
        return pulumi.get(self, "zookeeper")

    @zookeeper.setter
    def zookeeper(self, value: Optional[pulumi.Input['MdbClickhouseClusterZookeeperArgs']]):
        pulumi.set(self, "zookeeper", value)


@pulumi.input_type
class _MdbClickhouseClusterState:
    def __init__(__self__, *,
                 access: Optional[pulumi.Input['MdbClickhouseClusterAccessArgs']] = None,
                 admin_password: Optional[pulumi.Input[str]] = None,
                 backup_window_start: Optional[pulumi.Input['MdbClickhouseClusterBackupWindowStartArgs']] = None,
                 clickhouse: Optional[pulumi.Input['MdbClickhouseClusterClickhouseArgs']] = None,
                 cloud_storage: Optional[pulumi.Input['MdbClickhouseClusterCloudStorageArgs']] = None,
                 copy_schema_on_new_hosts: Optional[pulumi.Input[bool]] = None,
                 created_at: Optional[pulumi.Input[str]] = None,
                 databases: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterDatabaseArgs']]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 environment: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 format_schemas: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterFormatSchemaArgs']]]] = None,
                 health: Optional[pulumi.Input[str]] = None,
                 hosts: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterHostArgs']]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 ml_models: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterMlModelArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 shard_groups: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterShardGroupArgs']]]] = None,
                 sql_database_management: Optional[pulumi.Input[bool]] = None,
                 sql_user_management: Optional[pulumi.Input[bool]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterUserArgs']]]] = None,
                 version: Optional[pulumi.Input[str]] = None,
                 zookeeper: Optional[pulumi.Input['MdbClickhouseClusterZookeeperArgs']] = None):
        """
        Input properties used for looking up and filtering MdbClickhouseCluster resources.
        :param pulumi.Input['MdbClickhouseClusterAccessArgs'] access: Access policy to the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] admin_password: A password used to authorize as user `admin` when `sql_user_management` enabled.
        :param pulumi.Input['MdbClickhouseClusterBackupWindowStartArgs'] backup_window_start: Time to start the daily backup, in the UTC timezone. The structure is documented below.
        :param pulumi.Input['MdbClickhouseClusterClickhouseArgs'] clickhouse: Configuration of the ClickHouse subcluster. The structure is documented below.
        :param pulumi.Input[bool] copy_schema_on_new_hosts: Whether to copy schema on new ClickHouse hosts.
        :param pulumi.Input[str] created_at: Timestamp of cluster creation.
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterDatabaseArgs']]] databases: A database of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] description: Description of the shard group.
        :param pulumi.Input[str] environment: Deployment environment of the ClickHouse cluster. Can be either `PRESTABLE` or `PRODUCTION`.
        :param pulumi.Input[str] folder_id: The ID of the folder that the resource belongs to. If it
               is not provided, the default provider folder is used.
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterFormatSchemaArgs']]] format_schemas: A set of protobuf or capnproto format schemas. The structure is documented below.
        :param pulumi.Input[str] health: Aggregated health of the cluster. Can be either `ALIVE`, `DEGRADED`, `DEAD` or `HEALTH_UNKNOWN`.
               For more information see `health` field of JSON representation in [the official documentation](https://cloud.yandex.com/docs/managed-clickhouse/api-ref/Cluster/).
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterHostArgs']]] hosts: A host of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the ClickHouse cluster.
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterMlModelArgs']]] ml_models: A group of machine learning models. The structure is documented below
        :param pulumi.Input[str] name: Graphite rollup configuration name.
        :param pulumi.Input[str] network_id: ID of the network, to which the ClickHouse cluster belongs.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: A set of ids of security groups assigned to hosts of the cluster.
        :param pulumi.Input[str] service_account_id: ID of the service account used for access to Yandex Object Storage.
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterShardGroupArgs']]] shard_groups: A group of clickhouse shards. The structure is documented below.
        :param pulumi.Input[bool] sql_database_management: Grants `admin` user database management permission.
        :param pulumi.Input[bool] sql_user_management: Enables `admin` user with user management permission.
        :param pulumi.Input[str] status: Status of the cluster. Can be either `CREATING`, `STARTING`, `RUNNING`, `UPDATING`, `STOPPING`, `STOPPED`, `ERROR` or `STATUS_UNKNOWN`.
               For more information see `status` field of JSON representation in [the official documentation](https://cloud.yandex.com/docs/managed-clickhouse/api-ref/Cluster/).
        :param pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterUserArgs']]] users: A user of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] version: Version of the ClickHouse server software.
        :param pulumi.Input['MdbClickhouseClusterZookeeperArgs'] zookeeper: Configuration of the ZooKeeper subcluster. The structure is documented below.
        """
        if access is not None:
            pulumi.set(__self__, "access", access)
        if admin_password is not None:
            pulumi.set(__self__, "admin_password", admin_password)
        if backup_window_start is not None:
            pulumi.set(__self__, "backup_window_start", backup_window_start)
        if clickhouse is not None:
            pulumi.set(__self__, "clickhouse", clickhouse)
        if cloud_storage is not None:
            pulumi.set(__self__, "cloud_storage", cloud_storage)
        if copy_schema_on_new_hosts is not None:
            pulumi.set(__self__, "copy_schema_on_new_hosts", copy_schema_on_new_hosts)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if databases is not None:
            pulumi.set(__self__, "databases", databases)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if environment is not None:
            pulumi.set(__self__, "environment", environment)
        if folder_id is not None:
            pulumi.set(__self__, "folder_id", folder_id)
        if format_schemas is not None:
            pulumi.set(__self__, "format_schemas", format_schemas)
        if health is not None:
            pulumi.set(__self__, "health", health)
        if hosts is not None:
            pulumi.set(__self__, "hosts", hosts)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if ml_models is not None:
            pulumi.set(__self__, "ml_models", ml_models)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_id is not None:
            pulumi.set(__self__, "network_id", network_id)
        if security_group_ids is not None:
            pulumi.set(__self__, "security_group_ids", security_group_ids)
        if service_account_id is not None:
            pulumi.set(__self__, "service_account_id", service_account_id)
        if shard_groups is not None:
            pulumi.set(__self__, "shard_groups", shard_groups)
        if sql_database_management is not None:
            pulumi.set(__self__, "sql_database_management", sql_database_management)
        if sql_user_management is not None:
            pulumi.set(__self__, "sql_user_management", sql_user_management)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if users is not None:
            pulumi.set(__self__, "users", users)
        if version is not None:
            pulumi.set(__self__, "version", version)
        if zookeeper is not None:
            pulumi.set(__self__, "zookeeper", zookeeper)

    @property
    @pulumi.getter
    def access(self) -> Optional[pulumi.Input['MdbClickhouseClusterAccessArgs']]:
        """
        Access policy to the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "access")

    @access.setter
    def access(self, value: Optional[pulumi.Input['MdbClickhouseClusterAccessArgs']]):
        pulumi.set(self, "access", value)

    @property
    @pulumi.getter(name="adminPassword")
    def admin_password(self) -> Optional[pulumi.Input[str]]:
        """
        A password used to authorize as user `admin` when `sql_user_management` enabled.
        """
        return pulumi.get(self, "admin_password")

    @admin_password.setter
    def admin_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "admin_password", value)

    @property
    @pulumi.getter(name="backupWindowStart")
    def backup_window_start(self) -> Optional[pulumi.Input['MdbClickhouseClusterBackupWindowStartArgs']]:
        """
        Time to start the daily backup, in the UTC timezone. The structure is documented below.
        """
        return pulumi.get(self, "backup_window_start")

    @backup_window_start.setter
    def backup_window_start(self, value: Optional[pulumi.Input['MdbClickhouseClusterBackupWindowStartArgs']]):
        pulumi.set(self, "backup_window_start", value)

    @property
    @pulumi.getter
    def clickhouse(self) -> Optional[pulumi.Input['MdbClickhouseClusterClickhouseArgs']]:
        """
        Configuration of the ClickHouse subcluster. The structure is documented below.
        """
        return pulumi.get(self, "clickhouse")

    @clickhouse.setter
    def clickhouse(self, value: Optional[pulumi.Input['MdbClickhouseClusterClickhouseArgs']]):
        pulumi.set(self, "clickhouse", value)

    @property
    @pulumi.getter(name="cloudStorage")
    def cloud_storage(self) -> Optional[pulumi.Input['MdbClickhouseClusterCloudStorageArgs']]:
        return pulumi.get(self, "cloud_storage")

    @cloud_storage.setter
    def cloud_storage(self, value: Optional[pulumi.Input['MdbClickhouseClusterCloudStorageArgs']]):
        pulumi.set(self, "cloud_storage", value)

    @property
    @pulumi.getter(name="copySchemaOnNewHosts")
    def copy_schema_on_new_hosts(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to copy schema on new ClickHouse hosts.
        """
        return pulumi.get(self, "copy_schema_on_new_hosts")

    @copy_schema_on_new_hosts.setter
    def copy_schema_on_new_hosts(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "copy_schema_on_new_hosts", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        Timestamp of cluster creation.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter
    def databases(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterDatabaseArgs']]]]:
        """
        A database of the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "databases")

    @databases.setter
    def databases(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterDatabaseArgs']]]]):
        pulumi.set(self, "databases", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the shard group.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def environment(self) -> Optional[pulumi.Input[str]]:
        """
        Deployment environment of the ClickHouse cluster. Can be either `PRESTABLE` or `PRODUCTION`.
        """
        return pulumi.get(self, "environment")

    @environment.setter
    def environment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "environment", value)

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the folder that the resource belongs to. If it
        is not provided, the default provider folder is used.
        """
        return pulumi.get(self, "folder_id")

    @folder_id.setter
    def folder_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "folder_id", value)

    @property
    @pulumi.getter(name="formatSchemas")
    def format_schemas(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterFormatSchemaArgs']]]]:
        """
        A set of protobuf or capnproto format schemas. The structure is documented below.
        """
        return pulumi.get(self, "format_schemas")

    @format_schemas.setter
    def format_schemas(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterFormatSchemaArgs']]]]):
        pulumi.set(self, "format_schemas", value)

    @property
    @pulumi.getter
    def health(self) -> Optional[pulumi.Input[str]]:
        """
        Aggregated health of the cluster. Can be either `ALIVE`, `DEGRADED`, `DEAD` or `HEALTH_UNKNOWN`.
        For more information see `health` field of JSON representation in [the official documentation](https://cloud.yandex.com/docs/managed-clickhouse/api-ref/Cluster/).
        """
        return pulumi.get(self, "health")

    @health.setter
    def health(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "health", value)

    @property
    @pulumi.getter
    def hosts(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterHostArgs']]]]:
        """
        A host of the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "hosts")

    @hosts.setter
    def hosts(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterHostArgs']]]]):
        pulumi.set(self, "hosts", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        A set of key/value label pairs to assign to the ClickHouse cluster.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter(name="mlModels")
    def ml_models(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterMlModelArgs']]]]:
        """
        A group of machine learning models. The structure is documented below
        """
        return pulumi.get(self, "ml_models")

    @ml_models.setter
    def ml_models(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterMlModelArgs']]]]):
        pulumi.set(self, "ml_models", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Graphite rollup configuration name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the network, to which the ClickHouse cluster belongs.
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A set of ids of security groups assigned to hosts of the cluster.
        """
        return pulumi.get(self, "security_group_ids")

    @security_group_ids.setter
    def security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_group_ids", value)

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the service account used for access to Yandex Object Storage.
        """
        return pulumi.get(self, "service_account_id")

    @service_account_id.setter
    def service_account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_account_id", value)

    @property
    @pulumi.getter(name="shardGroups")
    def shard_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterShardGroupArgs']]]]:
        """
        A group of clickhouse shards. The structure is documented below.
        """
        return pulumi.get(self, "shard_groups")

    @shard_groups.setter
    def shard_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterShardGroupArgs']]]]):
        pulumi.set(self, "shard_groups", value)

    @property
    @pulumi.getter(name="sqlDatabaseManagement")
    def sql_database_management(self) -> Optional[pulumi.Input[bool]]:
        """
        Grants `admin` user database management permission.
        """
        return pulumi.get(self, "sql_database_management")

    @sql_database_management.setter
    def sql_database_management(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "sql_database_management", value)

    @property
    @pulumi.getter(name="sqlUserManagement")
    def sql_user_management(self) -> Optional[pulumi.Input[bool]]:
        """
        Enables `admin` user with user management permission.
        """
        return pulumi.get(self, "sql_user_management")

    @sql_user_management.setter
    def sql_user_management(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "sql_user_management", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Status of the cluster. Can be either `CREATING`, `STARTING`, `RUNNING`, `UPDATING`, `STOPPING`, `STOPPED`, `ERROR` or `STATUS_UNKNOWN`.
        For more information see `status` field of JSON representation in [the official documentation](https://cloud.yandex.com/docs/managed-clickhouse/api-ref/Cluster/).
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def users(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterUserArgs']]]]:
        """
        A user of the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MdbClickhouseClusterUserArgs']]]]):
        pulumi.set(self, "users", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[str]]:
        """
        Version of the ClickHouse server software.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter
    def zookeeper(self) -> Optional[pulumi.Input['MdbClickhouseClusterZookeeperArgs']]:
        """
        Configuration of the ZooKeeper subcluster. The structure is documented below.
        """
        return pulumi.get(self, "zookeeper")

    @zookeeper.setter
    def zookeeper(self, value: Optional[pulumi.Input['MdbClickhouseClusterZookeeperArgs']]):
        pulumi.set(self, "zookeeper", value)


class MdbClickhouseCluster(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterAccessArgs']]] = None,
                 admin_password: Optional[pulumi.Input[str]] = None,
                 backup_window_start: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterBackupWindowStartArgs']]] = None,
                 clickhouse: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterClickhouseArgs']]] = None,
                 cloud_storage: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterCloudStorageArgs']]] = None,
                 copy_schema_on_new_hosts: Optional[pulumi.Input[bool]] = None,
                 databases: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterDatabaseArgs']]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 environment: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 format_schemas: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterFormatSchemaArgs']]]]] = None,
                 hosts: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterHostArgs']]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 ml_models: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterMlModelArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 shard_groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterShardGroupArgs']]]]] = None,
                 sql_database_management: Optional[pulumi.Input[bool]] = None,
                 sql_user_management: Optional[pulumi.Input[bool]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterUserArgs']]]]] = None,
                 version: Optional[pulumi.Input[str]] = None,
                 zookeeper: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterZookeeperArgs']]] = None,
                 __props__=None):
        """
        Manages a ClickHouse cluster within the Yandex.Cloud. For more information, see
        [the official documentation](https://cloud.yandex.com/docs/managed-clickhouse/concepts).

        ## Example Usage

        Example of creating a Single Node ClickHouse.

        ```python
        import pulumi
        import pulumi_yandex as yandex

        foo_vpc_network = yandex.VpcNetwork("fooVpcNetwork")
        foo_vpc_subnet = yandex.VpcSubnet("fooVpcSubnet",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.5.0.0/24"],
            zone="ru-central1-a")
        foo_mdb_clickhouse_cluster = yandex.MdbClickhouseCluster("fooMdbClickhouseCluster",
            clickhouse=yandex.MdbClickhouseClusterClickhouseArgs(
                config=yandex.MdbClickhouseClusterClickhouseConfigArgs(
                    background_pool_size=16,
                    background_schedule_pool_size=16,
                    compression=[
                        {
                            "method": "LZ4",
                            "minPartSize": 1024,
                            "minPartSizeRatio": 0.5,
                        },
                        {
                            "method": "ZSTD",
                            "minPartSize": 2048,
                            "minPartSizeRatio": 0.7,
                        },
                    ],
                    geobase_uri="",
                    graphite_rollup=[
                        {
                            "name": "rollup1",
                            "pattern": [{
                                "function": "func1",
                                "regexp": "abc",
                                "retention": [{
                                    "age": 1000,
                                    "precision": 3,
                                }],
                            }],
                        },
                        {
                            "name": "rollup2",
                            "pattern": [{
                                "function": "func2",
                                "retention": [{
                                    "age": 2000,
                                    "precision": 5,
                                }],
                            }],
                        },
                    ],
                    kafka=yandex.MdbClickhouseClusterClickhouseConfigKafkaArgs(
                        sasl_mechanism="SASL_MECHANISM_GSSAPI",
                        sasl_password="pass1",
                        sasl_username="user1",
                        security_protocol="SECURITY_PROTOCOL_PLAINTEXT",
                    ),
                    kafka_topic=[
                        {
                            "name": "topic1",
                            "settings": {
                                "saslMechanism": "SASL_MECHANISM_SCRAM_SHA_256",
                                "saslPassword": "pass2",
                                "saslUsername": "user2",
                                "securityProtocol": "SECURITY_PROTOCOL_SSL",
                            },
                        },
                        {
                            "name": "topic2",
                            "settings": {
                                "saslMechanism": "SASL_MECHANISM_PLAIN",
                                "securityProtocol": "SECURITY_PROTOCOL_SASL_PLAINTEXT",
                            },
                        },
                    ],
                    keep_alive_timeout=3000,
                    log_level="TRACE",
                    mark_cache_size=5368709120,
                    max_concurrent_queries=50,
                    max_connections=100,
                    max_partition_size_to_drop=53687091200,
                    max_table_size_to_drop=53687091200,
                    merge_tree=yandex.MdbClickhouseClusterClickhouseConfigMergeTreeArgs(
                        max_bytes_to_merge_at_min_space_in_pool=1048576,
                        max_replicated_merges_in_queue=16,
                        number_of_free_entries_in_pool_to_lower_max_size_of_merge=8,
                        parts_to_delay_insert=150,
                        parts_to_throw_insert=300,
                        replicated_deduplication_window=100,
                        replicated_deduplication_window_seconds=604800,
                    ),
                    metric_log_enabled=True,
                    metric_log_retention_size=536870912,
                    metric_log_retention_time=2592000,
                    part_log_retention_size=536870912,
                    part_log_retention_time=2592000,
                    query_log_retention_size=1073741824,
                    query_log_retention_time=2592000,
                    query_thread_log_enabled=True,
                    query_thread_log_retention_size=536870912,
                    query_thread_log_retention_time=2592000,
                    rabbitmq=yandex.MdbClickhouseClusterClickhouseConfigRabbitmqArgs(
                        password="rabbit_pass",
                        username="rabbit_user",
                    ),
                    text_log_enabled=True,
                    text_log_level="TRACE",
                    text_log_retention_size=536870912,
                    text_log_retention_time=2592000,
                    timezone="UTC",
                    trace_log_enabled=True,
                    trace_log_retention_size=536870912,
                    trace_log_retention_time=2592000,
                    uncompressed_cache_size=8589934592,
                ),
                resources=yandex.MdbClickhouseClusterClickhouseResourcesArgs(
                    disk_size=32,
                    disk_type_id="network-ssd",
                    resource_preset_id="s2.micro",
                ),
            ),
            cloud_storage=yandex.MdbClickhouseClusterCloudStorageArgs(
                enabled=False,
            ),
            databases=[yandex.MdbClickhouseClusterDatabaseArgs(
                name="db_name",
            )],
            environment="PRESTABLE",
            format_schemas=[yandex.MdbClickhouseClusterFormatSchemaArgs(
                name="test_schema",
                type="FORMAT_SCHEMA_TYPE_CAPNPROTO",
                uri="https://storage.yandexcloud.net/ch-data/schema.proto",
            )],
            hosts=[yandex.MdbClickhouseClusterHostArgs(
                subnet_id=foo_vpc_subnet.id,
                type="CLICKHOUSE",
                zone="ru-central1-a",
            )],
            ml_models=[yandex.MdbClickhouseClusterMlModelArgs(
                name="test_model",
                type="ML_MODEL_TYPE_CATBOOST",
                uri="https://storage.yandexcloud.net/ch-data/train.csv",
            )],
            network_id=foo_vpc_network.id,
            service_account_id="your_service_account_id",
            users=[yandex.MdbClickhouseClusterUserArgs(
                name="user",
                password="your_password",
                permissions=[yandex.MdbClickhouseClusterUserPermissionArgs(
                    database_name="db_name",
                )],
                quotas=[
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        errors=1000,
                        interval_duration=3600000,
                        queries=10000,
                    ),
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        error=5000,
                        interval_duration=79800000,
                        queries=50000,
                    ),
                ],
                settings=yandex.MdbClickhouseClusterUserSettingsArgs(
                    max_memory_usage_for_user=1000000000,
                    output_format_json_quote64bit_integers=True,
                    read_overflow_mode="throw",
                ),
            )])
        ```

        Example of creating a HA ClickHouse Cluster.

        ```python
        import pulumi
        import pulumi_yandex as yandex

        foo_vpc_network = yandex.VpcNetwork("fooVpcNetwork")
        foo_vpc_subnet = yandex.VpcSubnet("fooVpcSubnet",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.1.0.0/24"],
            zone="ru-central1-a")
        bar = yandex.VpcSubnet("bar",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.2.0.0/24"],
            zone="ru-central1-b")
        baz = yandex.VpcSubnet("baz",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.3.0.0/24"],
            zone="ru-central1-c")
        foo_mdb_clickhouse_cluster = yandex.MdbClickhouseCluster("fooMdbClickhouseCluster",
            clickhouse=yandex.MdbClickhouseClusterClickhouseArgs(
                resources=yandex.MdbClickhouseClusterClickhouseResourcesArgs(
                    disk_size=16,
                    disk_type_id="network-ssd",
                    resource_preset_id="s2.micro",
                ),
            ),
            cloud_storage=yandex.MdbClickhouseClusterCloudStorageArgs(
                enabled=False,
            ),
            databases=[yandex.MdbClickhouseClusterDatabaseArgs(
                name="db_name",
            )],
            environment="PRESTABLE",
            hosts=[
                yandex.MdbClickhouseClusterHostArgs(
                    subnet_id=foo_vpc_subnet.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-a",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    subnet_id=bar.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-b",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    subnet_id=foo_vpc_subnet.id,
                    type="ZOOKEEPER",
                    zone="ru-central1-a",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    subnet_id=bar.id,
                    type="ZOOKEEPER",
                    zone="ru-central1-b",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    subnet_id=baz.id,
                    type="ZOOKEEPER",
                    zone="ru-central1-c",
                ),
            ],
            network_id=foo_vpc_network.id,
            users=[yandex.MdbClickhouseClusterUserArgs(
                name="user",
                password="password",
                permissions=[yandex.MdbClickhouseClusterUserPermissionArgs(
                    database_name="db_name",
                )],
                quotas=[
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        errors=1000,
                        interval_duration=3600000,
                        queries=10000,
                    ),
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        error=5000,
                        interval_duration=79800000,
                        queries=50000,
                    ),
                ],
                settings=yandex.MdbClickhouseClusterUserSettingsArgs(
                    max_memory_usage_for_user=1000000000,
                    output_format_json_quote64bit_integers=True,
                    read_overflow_mode="throw",
                ),
            )],
            zookeeper=yandex.MdbClickhouseClusterZookeeperArgs(
                resources=yandex.MdbClickhouseClusterZookeeperResourcesArgs(
                    disk_size=10,
                    disk_type_id="network-ssd",
                    resource_preset_id="s2.micro",
                ),
            ))
        ```

        Example of creating a sharded ClickHouse Cluster.

        ```python
        import pulumi
        import pulumi_yandex as yandex

        foo_vpc_network = yandex.VpcNetwork("fooVpcNetwork")
        foo_vpc_subnet = yandex.VpcSubnet("fooVpcSubnet",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.1.0.0/24"],
            zone="ru-central1-a")
        bar = yandex.VpcSubnet("bar",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.2.0.0/24"],
            zone="ru-central1-b")
        baz = yandex.VpcSubnet("baz",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.3.0.0/24"],
            zone="ru-central1-c")
        foo_mdb_clickhouse_cluster = yandex.MdbClickhouseCluster("fooMdbClickhouseCluster",
            clickhouse=yandex.MdbClickhouseClusterClickhouseArgs(
                resources=yandex.MdbClickhouseClusterClickhouseResourcesArgs(
                    disk_size=16,
                    disk_type_id="network-ssd",
                    resource_preset_id="s2.micro",
                ),
            ),
            cloud_storage=yandex.MdbClickhouseClusterCloudStorageArgs(
                enabled=False,
            ),
            databases=[yandex.MdbClickhouseClusterDatabaseArgs(
                name="db_name",
            )],
            environment="PRODUCTION",
            hosts=[
                yandex.MdbClickhouseClusterHostArgs(
                    shard_name="shard1",
                    subnet_id=foo_vpc_subnet.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-a",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    shard_name="shard1",
                    subnet_id=bar.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-b",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    shard_name="shard2",
                    subnet_id=bar.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-b",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    shard_name="shard2",
                    subnet_id=baz.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-c",
                ),
            ],
            network_id=foo_vpc_network.id,
            shard_groups=[yandex.MdbClickhouseClusterShardGroupArgs(
                description="Cluster configuration that contain only shard1",
                name="single_shard_group",
                shard_names=["shard1"],
            )],
            users=[yandex.MdbClickhouseClusterUserArgs(
                name="user",
                password="password",
                permissions=[yandex.MdbClickhouseClusterUserPermissionArgs(
                    database_name="db_name",
                )],
                quotas=[
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        errors=1000,
                        interval_duration=3600000,
                        queries=10000,
                    ),
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        error=5000,
                        interval_duration=79800000,
                        queries=50000,
                    ),
                ],
                settings=yandex.MdbClickhouseClusterUserSettingsArgs(
                    max_memory_usage_for_user=1000000000,
                    output_format_json_quote64bit_integers=True,
                    read_overflow_mode="throw",
                ),
            )],
            zookeeper=yandex.MdbClickhouseClusterZookeeperArgs(
                resources=yandex.MdbClickhouseClusterZookeeperResourcesArgs(
                    disk_size=10,
                    disk_type_id="network-ssd",
                    resource_preset_id="s2.micro",
                ),
            ))
        ```

        ## Import

        A cluster can be imported using the `id` of the resource, e.g.

        ```sh
         $ pulumi import yandex:index/mdbClickhouseCluster:MdbClickhouseCluster foo cluster_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['MdbClickhouseClusterAccessArgs']] access: Access policy to the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] admin_password: A password used to authorize as user `admin` when `sql_user_management` enabled.
        :param pulumi.Input[pulumi.InputType['MdbClickhouseClusterBackupWindowStartArgs']] backup_window_start: Time to start the daily backup, in the UTC timezone. The structure is documented below.
        :param pulumi.Input[pulumi.InputType['MdbClickhouseClusterClickhouseArgs']] clickhouse: Configuration of the ClickHouse subcluster. The structure is documented below.
        :param pulumi.Input[bool] copy_schema_on_new_hosts: Whether to copy schema on new ClickHouse hosts.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterDatabaseArgs']]]] databases: A database of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] description: Description of the shard group.
        :param pulumi.Input[str] environment: Deployment environment of the ClickHouse cluster. Can be either `PRESTABLE` or `PRODUCTION`.
        :param pulumi.Input[str] folder_id: The ID of the folder that the resource belongs to. If it
               is not provided, the default provider folder is used.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterFormatSchemaArgs']]]] format_schemas: A set of protobuf or capnproto format schemas. The structure is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterHostArgs']]]] hosts: A host of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the ClickHouse cluster.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterMlModelArgs']]]] ml_models: A group of machine learning models. The structure is documented below
        :param pulumi.Input[str] name: Graphite rollup configuration name.
        :param pulumi.Input[str] network_id: ID of the network, to which the ClickHouse cluster belongs.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: A set of ids of security groups assigned to hosts of the cluster.
        :param pulumi.Input[str] service_account_id: ID of the service account used for access to Yandex Object Storage.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterShardGroupArgs']]]] shard_groups: A group of clickhouse shards. The structure is documented below.
        :param pulumi.Input[bool] sql_database_management: Grants `admin` user database management permission.
        :param pulumi.Input[bool] sql_user_management: Enables `admin` user with user management permission.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterUserArgs']]]] users: A user of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] version: Version of the ClickHouse server software.
        :param pulumi.Input[pulumi.InputType['MdbClickhouseClusterZookeeperArgs']] zookeeper: Configuration of the ZooKeeper subcluster. The structure is documented below.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MdbClickhouseClusterArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a ClickHouse cluster within the Yandex.Cloud. For more information, see
        [the official documentation](https://cloud.yandex.com/docs/managed-clickhouse/concepts).

        ## Example Usage

        Example of creating a Single Node ClickHouse.

        ```python
        import pulumi
        import pulumi_yandex as yandex

        foo_vpc_network = yandex.VpcNetwork("fooVpcNetwork")
        foo_vpc_subnet = yandex.VpcSubnet("fooVpcSubnet",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.5.0.0/24"],
            zone="ru-central1-a")
        foo_mdb_clickhouse_cluster = yandex.MdbClickhouseCluster("fooMdbClickhouseCluster",
            clickhouse=yandex.MdbClickhouseClusterClickhouseArgs(
                config=yandex.MdbClickhouseClusterClickhouseConfigArgs(
                    background_pool_size=16,
                    background_schedule_pool_size=16,
                    compression=[
                        {
                            "method": "LZ4",
                            "minPartSize": 1024,
                            "minPartSizeRatio": 0.5,
                        },
                        {
                            "method": "ZSTD",
                            "minPartSize": 2048,
                            "minPartSizeRatio": 0.7,
                        },
                    ],
                    geobase_uri="",
                    graphite_rollup=[
                        {
                            "name": "rollup1",
                            "pattern": [{
                                "function": "func1",
                                "regexp": "abc",
                                "retention": [{
                                    "age": 1000,
                                    "precision": 3,
                                }],
                            }],
                        },
                        {
                            "name": "rollup2",
                            "pattern": [{
                                "function": "func2",
                                "retention": [{
                                    "age": 2000,
                                    "precision": 5,
                                }],
                            }],
                        },
                    ],
                    kafka=yandex.MdbClickhouseClusterClickhouseConfigKafkaArgs(
                        sasl_mechanism="SASL_MECHANISM_GSSAPI",
                        sasl_password="pass1",
                        sasl_username="user1",
                        security_protocol="SECURITY_PROTOCOL_PLAINTEXT",
                    ),
                    kafka_topic=[
                        {
                            "name": "topic1",
                            "settings": {
                                "saslMechanism": "SASL_MECHANISM_SCRAM_SHA_256",
                                "saslPassword": "pass2",
                                "saslUsername": "user2",
                                "securityProtocol": "SECURITY_PROTOCOL_SSL",
                            },
                        },
                        {
                            "name": "topic2",
                            "settings": {
                                "saslMechanism": "SASL_MECHANISM_PLAIN",
                                "securityProtocol": "SECURITY_PROTOCOL_SASL_PLAINTEXT",
                            },
                        },
                    ],
                    keep_alive_timeout=3000,
                    log_level="TRACE",
                    mark_cache_size=5368709120,
                    max_concurrent_queries=50,
                    max_connections=100,
                    max_partition_size_to_drop=53687091200,
                    max_table_size_to_drop=53687091200,
                    merge_tree=yandex.MdbClickhouseClusterClickhouseConfigMergeTreeArgs(
                        max_bytes_to_merge_at_min_space_in_pool=1048576,
                        max_replicated_merges_in_queue=16,
                        number_of_free_entries_in_pool_to_lower_max_size_of_merge=8,
                        parts_to_delay_insert=150,
                        parts_to_throw_insert=300,
                        replicated_deduplication_window=100,
                        replicated_deduplication_window_seconds=604800,
                    ),
                    metric_log_enabled=True,
                    metric_log_retention_size=536870912,
                    metric_log_retention_time=2592000,
                    part_log_retention_size=536870912,
                    part_log_retention_time=2592000,
                    query_log_retention_size=1073741824,
                    query_log_retention_time=2592000,
                    query_thread_log_enabled=True,
                    query_thread_log_retention_size=536870912,
                    query_thread_log_retention_time=2592000,
                    rabbitmq=yandex.MdbClickhouseClusterClickhouseConfigRabbitmqArgs(
                        password="rabbit_pass",
                        username="rabbit_user",
                    ),
                    text_log_enabled=True,
                    text_log_level="TRACE",
                    text_log_retention_size=536870912,
                    text_log_retention_time=2592000,
                    timezone="UTC",
                    trace_log_enabled=True,
                    trace_log_retention_size=536870912,
                    trace_log_retention_time=2592000,
                    uncompressed_cache_size=8589934592,
                ),
                resources=yandex.MdbClickhouseClusterClickhouseResourcesArgs(
                    disk_size=32,
                    disk_type_id="network-ssd",
                    resource_preset_id="s2.micro",
                ),
            ),
            cloud_storage=yandex.MdbClickhouseClusterCloudStorageArgs(
                enabled=False,
            ),
            databases=[yandex.MdbClickhouseClusterDatabaseArgs(
                name="db_name",
            )],
            environment="PRESTABLE",
            format_schemas=[yandex.MdbClickhouseClusterFormatSchemaArgs(
                name="test_schema",
                type="FORMAT_SCHEMA_TYPE_CAPNPROTO",
                uri="https://storage.yandexcloud.net/ch-data/schema.proto",
            )],
            hosts=[yandex.MdbClickhouseClusterHostArgs(
                subnet_id=foo_vpc_subnet.id,
                type="CLICKHOUSE",
                zone="ru-central1-a",
            )],
            ml_models=[yandex.MdbClickhouseClusterMlModelArgs(
                name="test_model",
                type="ML_MODEL_TYPE_CATBOOST",
                uri="https://storage.yandexcloud.net/ch-data/train.csv",
            )],
            network_id=foo_vpc_network.id,
            service_account_id="your_service_account_id",
            users=[yandex.MdbClickhouseClusterUserArgs(
                name="user",
                password="your_password",
                permissions=[yandex.MdbClickhouseClusterUserPermissionArgs(
                    database_name="db_name",
                )],
                quotas=[
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        errors=1000,
                        interval_duration=3600000,
                        queries=10000,
                    ),
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        error=5000,
                        interval_duration=79800000,
                        queries=50000,
                    ),
                ],
                settings=yandex.MdbClickhouseClusterUserSettingsArgs(
                    max_memory_usage_for_user=1000000000,
                    output_format_json_quote64bit_integers=True,
                    read_overflow_mode="throw",
                ),
            )])
        ```

        Example of creating a HA ClickHouse Cluster.

        ```python
        import pulumi
        import pulumi_yandex as yandex

        foo_vpc_network = yandex.VpcNetwork("fooVpcNetwork")
        foo_vpc_subnet = yandex.VpcSubnet("fooVpcSubnet",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.1.0.0/24"],
            zone="ru-central1-a")
        bar = yandex.VpcSubnet("bar",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.2.0.0/24"],
            zone="ru-central1-b")
        baz = yandex.VpcSubnet("baz",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.3.0.0/24"],
            zone="ru-central1-c")
        foo_mdb_clickhouse_cluster = yandex.MdbClickhouseCluster("fooMdbClickhouseCluster",
            clickhouse=yandex.MdbClickhouseClusterClickhouseArgs(
                resources=yandex.MdbClickhouseClusterClickhouseResourcesArgs(
                    disk_size=16,
                    disk_type_id="network-ssd",
                    resource_preset_id="s2.micro",
                ),
            ),
            cloud_storage=yandex.MdbClickhouseClusterCloudStorageArgs(
                enabled=False,
            ),
            databases=[yandex.MdbClickhouseClusterDatabaseArgs(
                name="db_name",
            )],
            environment="PRESTABLE",
            hosts=[
                yandex.MdbClickhouseClusterHostArgs(
                    subnet_id=foo_vpc_subnet.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-a",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    subnet_id=bar.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-b",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    subnet_id=foo_vpc_subnet.id,
                    type="ZOOKEEPER",
                    zone="ru-central1-a",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    subnet_id=bar.id,
                    type="ZOOKEEPER",
                    zone="ru-central1-b",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    subnet_id=baz.id,
                    type="ZOOKEEPER",
                    zone="ru-central1-c",
                ),
            ],
            network_id=foo_vpc_network.id,
            users=[yandex.MdbClickhouseClusterUserArgs(
                name="user",
                password="password",
                permissions=[yandex.MdbClickhouseClusterUserPermissionArgs(
                    database_name="db_name",
                )],
                quotas=[
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        errors=1000,
                        interval_duration=3600000,
                        queries=10000,
                    ),
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        error=5000,
                        interval_duration=79800000,
                        queries=50000,
                    ),
                ],
                settings=yandex.MdbClickhouseClusterUserSettingsArgs(
                    max_memory_usage_for_user=1000000000,
                    output_format_json_quote64bit_integers=True,
                    read_overflow_mode="throw",
                ),
            )],
            zookeeper=yandex.MdbClickhouseClusterZookeeperArgs(
                resources=yandex.MdbClickhouseClusterZookeeperResourcesArgs(
                    disk_size=10,
                    disk_type_id="network-ssd",
                    resource_preset_id="s2.micro",
                ),
            ))
        ```

        Example of creating a sharded ClickHouse Cluster.

        ```python
        import pulumi
        import pulumi_yandex as yandex

        foo_vpc_network = yandex.VpcNetwork("fooVpcNetwork")
        foo_vpc_subnet = yandex.VpcSubnet("fooVpcSubnet",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.1.0.0/24"],
            zone="ru-central1-a")
        bar = yandex.VpcSubnet("bar",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.2.0.0/24"],
            zone="ru-central1-b")
        baz = yandex.VpcSubnet("baz",
            network_id=foo_vpc_network.id,
            v4_cidr_blocks=["10.3.0.0/24"],
            zone="ru-central1-c")
        foo_mdb_clickhouse_cluster = yandex.MdbClickhouseCluster("fooMdbClickhouseCluster",
            clickhouse=yandex.MdbClickhouseClusterClickhouseArgs(
                resources=yandex.MdbClickhouseClusterClickhouseResourcesArgs(
                    disk_size=16,
                    disk_type_id="network-ssd",
                    resource_preset_id="s2.micro",
                ),
            ),
            cloud_storage=yandex.MdbClickhouseClusterCloudStorageArgs(
                enabled=False,
            ),
            databases=[yandex.MdbClickhouseClusterDatabaseArgs(
                name="db_name",
            )],
            environment="PRODUCTION",
            hosts=[
                yandex.MdbClickhouseClusterHostArgs(
                    shard_name="shard1",
                    subnet_id=foo_vpc_subnet.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-a",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    shard_name="shard1",
                    subnet_id=bar.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-b",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    shard_name="shard2",
                    subnet_id=bar.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-b",
                ),
                yandex.MdbClickhouseClusterHostArgs(
                    shard_name="shard2",
                    subnet_id=baz.id,
                    type="CLICKHOUSE",
                    zone="ru-central1-c",
                ),
            ],
            network_id=foo_vpc_network.id,
            shard_groups=[yandex.MdbClickhouseClusterShardGroupArgs(
                description="Cluster configuration that contain only shard1",
                name="single_shard_group",
                shard_names=["shard1"],
            )],
            users=[yandex.MdbClickhouseClusterUserArgs(
                name="user",
                password="password",
                permissions=[yandex.MdbClickhouseClusterUserPermissionArgs(
                    database_name="db_name",
                )],
                quotas=[
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        errors=1000,
                        interval_duration=3600000,
                        queries=10000,
                    ),
                    yandex.MdbClickhouseClusterUserQuotaArgs(
                        error=5000,
                        interval_duration=79800000,
                        queries=50000,
                    ),
                ],
                settings=yandex.MdbClickhouseClusterUserSettingsArgs(
                    max_memory_usage_for_user=1000000000,
                    output_format_json_quote64bit_integers=True,
                    read_overflow_mode="throw",
                ),
            )],
            zookeeper=yandex.MdbClickhouseClusterZookeeperArgs(
                resources=yandex.MdbClickhouseClusterZookeeperResourcesArgs(
                    disk_size=10,
                    disk_type_id="network-ssd",
                    resource_preset_id="s2.micro",
                ),
            ))
        ```

        ## Import

        A cluster can be imported using the `id` of the resource, e.g.

        ```sh
         $ pulumi import yandex:index/mdbClickhouseCluster:MdbClickhouseCluster foo cluster_id
        ```

        :param str resource_name: The name of the resource.
        :param MdbClickhouseClusterArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MdbClickhouseClusterArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterAccessArgs']]] = None,
                 admin_password: Optional[pulumi.Input[str]] = None,
                 backup_window_start: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterBackupWindowStartArgs']]] = None,
                 clickhouse: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterClickhouseArgs']]] = None,
                 cloud_storage: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterCloudStorageArgs']]] = None,
                 copy_schema_on_new_hosts: Optional[pulumi.Input[bool]] = None,
                 databases: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterDatabaseArgs']]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 environment: Optional[pulumi.Input[str]] = None,
                 folder_id: Optional[pulumi.Input[str]] = None,
                 format_schemas: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterFormatSchemaArgs']]]]] = None,
                 hosts: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterHostArgs']]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 ml_models: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterMlModelArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 service_account_id: Optional[pulumi.Input[str]] = None,
                 shard_groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterShardGroupArgs']]]]] = None,
                 sql_database_management: Optional[pulumi.Input[bool]] = None,
                 sql_user_management: Optional[pulumi.Input[bool]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterUserArgs']]]]] = None,
                 version: Optional[pulumi.Input[str]] = None,
                 zookeeper: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterZookeeperArgs']]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MdbClickhouseClusterArgs.__new__(MdbClickhouseClusterArgs)

            __props__.__dict__["access"] = access
            __props__.__dict__["admin_password"] = admin_password
            __props__.__dict__["backup_window_start"] = backup_window_start
            if clickhouse is None and not opts.urn:
                raise TypeError("Missing required property 'clickhouse'")
            __props__.__dict__["clickhouse"] = clickhouse
            __props__.__dict__["cloud_storage"] = cloud_storage
            __props__.__dict__["copy_schema_on_new_hosts"] = copy_schema_on_new_hosts
            __props__.__dict__["databases"] = databases
            __props__.__dict__["description"] = description
            if environment is None and not opts.urn:
                raise TypeError("Missing required property 'environment'")
            __props__.__dict__["environment"] = environment
            __props__.__dict__["folder_id"] = folder_id
            __props__.__dict__["format_schemas"] = format_schemas
            if hosts is None and not opts.urn:
                raise TypeError("Missing required property 'hosts'")
            __props__.__dict__["hosts"] = hosts
            __props__.__dict__["labels"] = labels
            __props__.__dict__["ml_models"] = ml_models
            __props__.__dict__["name"] = name
            if network_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_id'")
            __props__.__dict__["network_id"] = network_id
            __props__.__dict__["security_group_ids"] = security_group_ids
            __props__.__dict__["service_account_id"] = service_account_id
            __props__.__dict__["shard_groups"] = shard_groups
            __props__.__dict__["sql_database_management"] = sql_database_management
            __props__.__dict__["sql_user_management"] = sql_user_management
            __props__.__dict__["users"] = users
            __props__.__dict__["version"] = version
            __props__.__dict__["zookeeper"] = zookeeper
            __props__.__dict__["created_at"] = None
            __props__.__dict__["health"] = None
            __props__.__dict__["status"] = None
        super(MdbClickhouseCluster, __self__).__init__(
            'yandex:index/mdbClickhouseCluster:MdbClickhouseCluster',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            access: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterAccessArgs']]] = None,
            admin_password: Optional[pulumi.Input[str]] = None,
            backup_window_start: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterBackupWindowStartArgs']]] = None,
            clickhouse: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterClickhouseArgs']]] = None,
            cloud_storage: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterCloudStorageArgs']]] = None,
            copy_schema_on_new_hosts: Optional[pulumi.Input[bool]] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            databases: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterDatabaseArgs']]]]] = None,
            description: Optional[pulumi.Input[str]] = None,
            environment: Optional[pulumi.Input[str]] = None,
            folder_id: Optional[pulumi.Input[str]] = None,
            format_schemas: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterFormatSchemaArgs']]]]] = None,
            health: Optional[pulumi.Input[str]] = None,
            hosts: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterHostArgs']]]]] = None,
            labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            ml_models: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterMlModelArgs']]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            network_id: Optional[pulumi.Input[str]] = None,
            security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            service_account_id: Optional[pulumi.Input[str]] = None,
            shard_groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterShardGroupArgs']]]]] = None,
            sql_database_management: Optional[pulumi.Input[bool]] = None,
            sql_user_management: Optional[pulumi.Input[bool]] = None,
            status: Optional[pulumi.Input[str]] = None,
            users: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterUserArgs']]]]] = None,
            version: Optional[pulumi.Input[str]] = None,
            zookeeper: Optional[pulumi.Input[pulumi.InputType['MdbClickhouseClusterZookeeperArgs']]] = None) -> 'MdbClickhouseCluster':
        """
        Get an existing MdbClickhouseCluster resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['MdbClickhouseClusterAccessArgs']] access: Access policy to the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] admin_password: A password used to authorize as user `admin` when `sql_user_management` enabled.
        :param pulumi.Input[pulumi.InputType['MdbClickhouseClusterBackupWindowStartArgs']] backup_window_start: Time to start the daily backup, in the UTC timezone. The structure is documented below.
        :param pulumi.Input[pulumi.InputType['MdbClickhouseClusterClickhouseArgs']] clickhouse: Configuration of the ClickHouse subcluster. The structure is documented below.
        :param pulumi.Input[bool] copy_schema_on_new_hosts: Whether to copy schema on new ClickHouse hosts.
        :param pulumi.Input[str] created_at: Timestamp of cluster creation.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterDatabaseArgs']]]] databases: A database of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] description: Description of the shard group.
        :param pulumi.Input[str] environment: Deployment environment of the ClickHouse cluster. Can be either `PRESTABLE` or `PRODUCTION`.
        :param pulumi.Input[str] folder_id: The ID of the folder that the resource belongs to. If it
               is not provided, the default provider folder is used.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterFormatSchemaArgs']]]] format_schemas: A set of protobuf or capnproto format schemas. The structure is documented below.
        :param pulumi.Input[str] health: Aggregated health of the cluster. Can be either `ALIVE`, `DEGRADED`, `DEAD` or `HEALTH_UNKNOWN`.
               For more information see `health` field of JSON representation in [the official documentation](https://cloud.yandex.com/docs/managed-clickhouse/api-ref/Cluster/).
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterHostArgs']]]] hosts: A host of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: A set of key/value label pairs to assign to the ClickHouse cluster.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterMlModelArgs']]]] ml_models: A group of machine learning models. The structure is documented below
        :param pulumi.Input[str] name: Graphite rollup configuration name.
        :param pulumi.Input[str] network_id: ID of the network, to which the ClickHouse cluster belongs.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: A set of ids of security groups assigned to hosts of the cluster.
        :param pulumi.Input[str] service_account_id: ID of the service account used for access to Yandex Object Storage.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterShardGroupArgs']]]] shard_groups: A group of clickhouse shards. The structure is documented below.
        :param pulumi.Input[bool] sql_database_management: Grants `admin` user database management permission.
        :param pulumi.Input[bool] sql_user_management: Enables `admin` user with user management permission.
        :param pulumi.Input[str] status: Status of the cluster. Can be either `CREATING`, `STARTING`, `RUNNING`, `UPDATING`, `STOPPING`, `STOPPED`, `ERROR` or `STATUS_UNKNOWN`.
               For more information see `status` field of JSON representation in [the official documentation](https://cloud.yandex.com/docs/managed-clickhouse/api-ref/Cluster/).
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['MdbClickhouseClusterUserArgs']]]] users: A user of the ClickHouse cluster. The structure is documented below.
        :param pulumi.Input[str] version: Version of the ClickHouse server software.
        :param pulumi.Input[pulumi.InputType['MdbClickhouseClusterZookeeperArgs']] zookeeper: Configuration of the ZooKeeper subcluster. The structure is documented below.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MdbClickhouseClusterState.__new__(_MdbClickhouseClusterState)

        __props__.__dict__["access"] = access
        __props__.__dict__["admin_password"] = admin_password
        __props__.__dict__["backup_window_start"] = backup_window_start
        __props__.__dict__["clickhouse"] = clickhouse
        __props__.__dict__["cloud_storage"] = cloud_storage
        __props__.__dict__["copy_schema_on_new_hosts"] = copy_schema_on_new_hosts
        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["databases"] = databases
        __props__.__dict__["description"] = description
        __props__.__dict__["environment"] = environment
        __props__.__dict__["folder_id"] = folder_id
        __props__.__dict__["format_schemas"] = format_schemas
        __props__.__dict__["health"] = health
        __props__.__dict__["hosts"] = hosts
        __props__.__dict__["labels"] = labels
        __props__.__dict__["ml_models"] = ml_models
        __props__.__dict__["name"] = name
        __props__.__dict__["network_id"] = network_id
        __props__.__dict__["security_group_ids"] = security_group_ids
        __props__.__dict__["service_account_id"] = service_account_id
        __props__.__dict__["shard_groups"] = shard_groups
        __props__.__dict__["sql_database_management"] = sql_database_management
        __props__.__dict__["sql_user_management"] = sql_user_management
        __props__.__dict__["status"] = status
        __props__.__dict__["users"] = users
        __props__.__dict__["version"] = version
        __props__.__dict__["zookeeper"] = zookeeper
        return MdbClickhouseCluster(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def access(self) -> pulumi.Output['outputs.MdbClickhouseClusterAccess']:
        """
        Access policy to the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "access")

    @property
    @pulumi.getter(name="adminPassword")
    def admin_password(self) -> pulumi.Output[Optional[str]]:
        """
        A password used to authorize as user `admin` when `sql_user_management` enabled.
        """
        return pulumi.get(self, "admin_password")

    @property
    @pulumi.getter(name="backupWindowStart")
    def backup_window_start(self) -> pulumi.Output['outputs.MdbClickhouseClusterBackupWindowStart']:
        """
        Time to start the daily backup, in the UTC timezone. The structure is documented below.
        """
        return pulumi.get(self, "backup_window_start")

    @property
    @pulumi.getter
    def clickhouse(self) -> pulumi.Output['outputs.MdbClickhouseClusterClickhouse']:
        """
        Configuration of the ClickHouse subcluster. The structure is documented below.
        """
        return pulumi.get(self, "clickhouse")

    @property
    @pulumi.getter(name="cloudStorage")
    def cloud_storage(self) -> pulumi.Output[Optional['outputs.MdbClickhouseClusterCloudStorage']]:
        return pulumi.get(self, "cloud_storage")

    @property
    @pulumi.getter(name="copySchemaOnNewHosts")
    def copy_schema_on_new_hosts(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether to copy schema on new ClickHouse hosts.
        """
        return pulumi.get(self, "copy_schema_on_new_hosts")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        Timestamp of cluster creation.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def databases(self) -> pulumi.Output[Optional[Sequence['outputs.MdbClickhouseClusterDatabase']]]:
        """
        A database of the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "databases")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Description of the shard group.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def environment(self) -> pulumi.Output[str]:
        """
        Deployment environment of the ClickHouse cluster. Can be either `PRESTABLE` or `PRODUCTION`.
        """
        return pulumi.get(self, "environment")

    @property
    @pulumi.getter(name="folderId")
    def folder_id(self) -> pulumi.Output[str]:
        """
        The ID of the folder that the resource belongs to. If it
        is not provided, the default provider folder is used.
        """
        return pulumi.get(self, "folder_id")

    @property
    @pulumi.getter(name="formatSchemas")
    def format_schemas(self) -> pulumi.Output[Optional[Sequence['outputs.MdbClickhouseClusterFormatSchema']]]:
        """
        A set of protobuf or capnproto format schemas. The structure is documented below.
        """
        return pulumi.get(self, "format_schemas")

    @property
    @pulumi.getter
    def health(self) -> pulumi.Output[str]:
        """
        Aggregated health of the cluster. Can be either `ALIVE`, `DEGRADED`, `DEAD` or `HEALTH_UNKNOWN`.
        For more information see `health` field of JSON representation in [the official documentation](https://cloud.yandex.com/docs/managed-clickhouse/api-ref/Cluster/).
        """
        return pulumi.get(self, "health")

    @property
    @pulumi.getter
    def hosts(self) -> pulumi.Output[Sequence['outputs.MdbClickhouseClusterHost']]:
        """
        A host of the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "hosts")

    @property
    @pulumi.getter
    def labels(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        A set of key/value label pairs to assign to the ClickHouse cluster.
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter(name="mlModels")
    def ml_models(self) -> pulumi.Output[Optional[Sequence['outputs.MdbClickhouseClusterMlModel']]]:
        """
        A group of machine learning models. The structure is documented below
        """
        return pulumi.get(self, "ml_models")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Graphite rollup configuration name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Output[str]:
        """
        ID of the network, to which the ClickHouse cluster belongs.
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        A set of ids of security groups assigned to hosts of the cluster.
        """
        return pulumi.get(self, "security_group_ids")

    @property
    @pulumi.getter(name="serviceAccountId")
    def service_account_id(self) -> pulumi.Output[str]:
        """
        ID of the service account used for access to Yandex Object Storage.
        """
        return pulumi.get(self, "service_account_id")

    @property
    @pulumi.getter(name="shardGroups")
    def shard_groups(self) -> pulumi.Output[Optional[Sequence['outputs.MdbClickhouseClusterShardGroup']]]:
        """
        A group of clickhouse shards. The structure is documented below.
        """
        return pulumi.get(self, "shard_groups")

    @property
    @pulumi.getter(name="sqlDatabaseManagement")
    def sql_database_management(self) -> pulumi.Output[bool]:
        """
        Grants `admin` user database management permission.
        """
        return pulumi.get(self, "sql_database_management")

    @property
    @pulumi.getter(name="sqlUserManagement")
    def sql_user_management(self) -> pulumi.Output[bool]:
        """
        Enables `admin` user with user management permission.
        """
        return pulumi.get(self, "sql_user_management")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Status of the cluster. Can be either `CREATING`, `STARTING`, `RUNNING`, `UPDATING`, `STOPPING`, `STOPPED`, `ERROR` or `STATUS_UNKNOWN`.
        For more information see `status` field of JSON representation in [the official documentation](https://cloud.yandex.com/docs/managed-clickhouse/api-ref/Cluster/).
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def users(self) -> pulumi.Output[Optional[Sequence['outputs.MdbClickhouseClusterUser']]]:
        """
        A user of the ClickHouse cluster. The structure is documented below.
        """
        return pulumi.get(self, "users")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[str]:
        """
        Version of the ClickHouse server software.
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter
    def zookeeper(self) -> pulumi.Output['outputs.MdbClickhouseClusterZookeeper']:
        """
        Configuration of the ZooKeeper subcluster. The structure is documented below.
        """
        return pulumi.get(self, "zookeeper")

